﻿var UserCollection = {
  Users: new Array(),
  addUser: function (data) {
    var U = UserCollection.Users[data.UserKey];
    if (!U) {
      U = new User();
    }
    U.UserKey = data.UserKey;
    U.DisplayName = data.DisplayName;
    U.GroupName = data.GroupName;
    U.UserStatus = data.UserStatus;
    U.UserGender = data.Gender;
    U.PersonalStatus = data.PersonalStatus;
    UserCollection.Users[data.UserKey] = U;
  },
  removeUser: function (key) {
    delete UserCollection.Users[key];
  },
  checkUserExists: function (key) {
    if (key in UserCollection.Users) {
      return true;
    } else {
      return false;
    }
  },
  getUser: function (key) {
    return UserCollection.Users[key];
  },
  getUsers: function () {
    return UserCollection.Users;
  },
  getGroupUsers: function (groupName) {
    var users = new Array();
    for (var key in UserCollection.Users) {
      var u = UserCollection.Users[key];
      if (u.GroupName == groupName) {
        users[users.length] = u;
      }
    }
    return users;
  },
  getGroups: function () {
    var groups = new Array();
    for (var key in UserCollection.Users) {
      var u = UserCollection.Users[key];
      var groupExist = false;
      $.each(groups, function (i, g) {
        if (g == u.GroupName) {
          groupExist = true;
        }
      });
      if (groupExist == false) {
        if (u.GroupName != undefined) {
          groups[groups.length] = u.GroupName;
        }
      }
    }
    groups.sort();
    return groups;
  },
  deleteAllUsers: function () {
    UserCollection.Users = new Array();
  },
  deleteAllUsersExceptMe: function () {
    for (var key in UserCollection.Users) {
      if (key != _LSCHAT.UserKey) {
        delete UserCollection.Users[key];
      }
    }
  }
}

var GroupCollection = {
  GChat: new Array(),
  addUser: function (key, msg) {
    try {
      if (msg == undefined) {
        return;
      }
      var Users;
      if (GroupCollection.checkGroupExists(key)) {
        Users = GroupCollection.getGroup(key);
      } else {
        Users = new Array();
      }
      var amsg = msg.split(CONSTANTS.GChtUserDelim);
      for (var i = 0; i < amsg.length; i++) {
        if (amsg[i] != _LSCHAT.UserKey) {
          if (this.userExist(Users, amsg[i]) == false) {
            Users.push(amsg[i]);
          }
        }
      }
      GroupCollection.GChat[key] = Users;
    } catch (e) {
      alert(e);
    }
  },
  usersCount: function (key) {
    var cnt = 0;
    if (GroupCollection.checkGroupExists(key)) {
      var users = GroupCollection.getGroup(key);
      if (users) {
        cnt = users.length;
      }
      if (cnt == 0) {
        GroupCollection.removeGroup(key);
      }
    }
    return cnt;
  },
  userExist: function (users, userkey) {
    var i; var userExist = false; for (i = 0; i < users.length; i++) {
      if (users[i] == userkey) { userExist = true; }
    }
    return userExist;
  },
  userAvailable: function (key, userkey) {
    var available = false;
    if (GroupCollection.checkGroupExists(key)) {
      var users = GroupCollection.getGroup(key);
      if (users) {
        return this.userExist(users, userkey);
      }
    }
    return available;
  },
  removeUser: function (key, user) {
    var Users;
    if (GroupCollection.checkGroupExists(key)) {
      Users = GroupCollection.getGroup(key);
      Users.splice(Users.indexOf(user), 1);
      GroupCollection.GChat[key] = Users;
    }
  },
  removeGroup: function (key) {
    delete GroupCollection.GChat[key];
  },
  checkGroupExists: function (key) {
    if (key in GroupCollection.GChat) {
      return true;
    } else {
      return false;
    }
  },
  getGroup: function (key) {
    return GroupCollection.GChat[key];
  },
  getGroups: function () {
    return GroupCollection.GChat;
  },
  deleteAllGroups: function () {
    GroupCollection.GChat = new Array();
  }
}

function User() {
  this.UserKey = '';
  this.DisplayName = '';
  this.GroupName = '';
  this.UserStatus = '';
  this.UserGender = '';
  this.PersonalStatus = '';
}
